package org.jeecg.modules.stm.wb.config.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;


import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.config.service.IWbCheckService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.wb.config.entity.WbCheck;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

 /**
 * @Description: 节点
 * @Author: jeecg-boot
 * @Date:   2025-06-13
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.config/wbCheck")
@Slf4j
public class WbCheckController extends JeecgController<WbCheck, IWbCheckService> {
	@Autowired
	private IWbCheckService wbCheckService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbCheck
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "节点-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbCheck>> queryPageList(WbCheck wbCheck,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbCheck> queryWrapper = QueryGenerator.initQueryWrapper(wbCheck, req.getParameterMap());
		Page<WbCheck> page = new Page<WbCheck>(pageNo, pageSize);
		IPage<WbCheck> pageList = wbCheckService.page(page, queryWrapper);
		return Result.OK(pageList);
	}


	 @GetMapping(value = "/alllist")
	 public Result<List<WbCheck>> queryPageList(WbCheck wbCheck,HttpServletRequest req) {
		 QueryWrapper<WbCheck> queryWrapper = QueryGenerator.initQueryWrapper(wbCheck, req.getParameterMap());
		 queryWrapper.orderByAsc("ind");
		 List<WbCheck> list = wbCheckService.list(queryWrapper);
		 return Result.OK(list);
	 }
	
	/**
	 *   添加
	 *
	 * @param wbCheck
	 * @return
	 */
	@AutoLog(value = "节点-添加")
	  
	@RequiresPermissions("wb.config:wb_check:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbCheck wbCheck) {
		wbCheckService.save(wbCheck);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbCheck
	 * @return
	 */
	@AutoLog(value = "节点-编辑")
	  
	@RequiresPermissions("wb.config:wb_check:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbCheck wbCheck) {
		wbCheckService.updateById(wbCheck);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "节点-通过id删除")
	  
	@RequiresPermissions("wb.config:wb_check:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbCheckService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "节点-批量删除")
	  
	@RequiresPermissions("wb.config:wb_check:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbCheckService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "节点-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbCheck> queryById(@RequestParam(name="id",required=true) String id) {
		WbCheck wbCheck = wbCheckService.getById(id);
		if(wbCheck==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbCheck);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbCheck
    */
    @RequiresPermissions("wb.config:wb_check:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbCheck wbCheck) {
        return super.exportXls(request, wbCheck, WbCheck.class, "节点");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.config:wb_check:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbCheck.class);
    }

}
